VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ZAP8055"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Private Declare Function OpenDevice Lib "k8055d.dll" (ByVal CardAddress As Long) As Long
Private Declare Sub CloseDevice Lib "k8055d.dll" ()

Private Declare Function ReadAnalogChannel Lib "k8055d.dll" (ByVal Channel As Long) As Long
Private Declare Sub ReadAllAnalog Lib "k8055d.dll" (Data1 As Long, Data2 As Long)
Private Declare Sub OutputAnalogChannel Lib "k8055d.dll" (ByVal Channel As Long, ByVal Data As Long)
Private Declare Sub OutputAllAnalog Lib "k8055d.dll" (ByVal Data1 As Long, ByVal Data2 As Long)
Private Declare Sub ClearAnalogChannel Lib "k8055d.dll" (ByVal Channel As Long)
Private Declare Sub SetAllAnalog Lib "k8055d.dll" ()
Private Declare Sub ClearAllAnalog Lib "k8055d.dll" ()
Private Declare Sub SetAnalogChannel Lib "k8055d.dll" (ByVal Channel As Long)

Private Declare Sub WriteAllDigital Lib "k8055d.dll" (ByVal Data As Long)
Private Declare Sub ClearDigitalChannel Lib "k8055d.dll" (ByVal Channel As Long)
Private Declare Sub ClearAllDigital Lib "k8055d.dll" ()
Private Declare Sub SetDigitalChannel Lib "k8055d.dll" (ByVal Channel As Long)
Private Declare Sub SetAllDigital Lib "k8055d.dll" ()
Private Declare Function ReadDigitalChannel Lib "k8055d.dll" (ByVal Channel As Long) As Boolean
Private Declare Function ReadAllDigital Lib "k8055d.dll" () As Long

Private Declare Function ReadCounter Lib "k8055d.dll" (ByVal CounterNr As Long) As Long
Private Declare Sub ResetCounter Lib "k8055d.dll" (ByVal CounterNr As Long)
Private Declare Sub SetCounterDebounceTime Lib "k8055d.dll" (ByVal CounterNr As Long, ByVal DebounceTime As Long)

Private Declare Function SearchDevices Lib "k8055d.dll" () As Long
Private Declare Function SetCurrentDevice Lib "k8055d.dll" (ByVal Address As Long) As Long
Private Declare Function Version Lib "k8055d.dll" () As Long

'Private Declare Function SetTimer Lib "user32" _
'            (ByVal hwnd As Long, _
'            ByVal nIDEvent As Long, _
'            ByVal uElapse As Long, _
'            ByVal lpTimerFunc As Long) As Long
'
'Private Declare Function KillTimer Lib "user32" _
'            (ByVal hwnd As Long, _
'            ByVal nIDEvent As Long) As Long
'
'Private Const nEventID As Long = 999
'Private Const WM_TIMER = &H113
'Private tmrRunning As Boolean
'Private timerID As Long
'Private icounter As Long
'
'Private Function TimerProc(ByVal hwnd As Long, _
'                     ByVal uMsg As Long, _
'                     ByVal idEvent As Long, _
'                     ByVal dwTime As Long) As Long
'   Select Case uMsg
'      Case WM_TIMER
'
'         If idEvent = nEventID Then
'            Debug.Print dwTime
'         End If
'
'      Case Else
'   End Select
'End Function

'Opens the communication link to the K8055 device
Public Function Open_Device(CardAddress As Long) As Long
'  Dim rs As Long
'  rs = OpenDevice(CardAddress)
'  If rs >= 0 Then
'    timerID = SetTimer(0, nEventID, 200, AddressOf TimerProc)
'  End If
  Open_Device = OpenDevice(CardAddress) 'rs
End Function

'Closes the link to the K8055 device
Public Sub Close_Device()
  CloseDevice
End Sub

'Reads the status of one analogue input-channel
Public Function Read_AnalogChannel(ByVal Channel As Long) As Long
  Read_AnalogChannel = ReadAnalogChannel(Channel)
End Function

'Reads the status of both analogue input-channels
Public Sub Read_AllAnalog(Data1 As Long, Data2 As Long)
  ReadAllAnalog Data1, Data2
End Sub

'Sets the analogue output channel according to the Data
Public Sub Output_AnalogChannel(ByVal Channel As Long, ByVal Data As Long)
  OutputAnalogChannel Channel, Data
End Sub

'Sets both analogue output channels according to the Data
Public Sub Output_AllAnalog(ByVal Data1 As Long, ByVal Data2 As Long)
  OutputAllAnalog Data1, Data2
End Sub

'Sets the analogue output channel to minimum
Public Sub Clear_AnalogChannel(ByVal Channel As Long)
  ClearAnalogChannel Channel
End Sub

'Sets all analogue output channels to maximum
Public Sub Set_AllAnalog()
  SetAllAnalog
End Sub

'Sets all analogue output channels to minimum
Public Sub Clear_AllAnalog()
  ClearAllAnalog
End Sub

'Sets the analogue output channel to maximum
Public Sub Set_AnalogChannel(ByVal Channel As Long)
  SetAnalogChannel Channel
End Sub

'Sets the digital outputs according to the data
Public Sub Write_AllDigital(ByVal Data As Long)
  WriteAllDigital Data
End Sub

'Clears the output channel
Public Sub Clear_DigitalChannel(ByVal Channel As Long)
  ClearDigitalChannel Channel
End Sub

'Clears all output channels
Public Sub Clear_AllDigital()
  ClearAllDigital
End Sub

'Sets the output channel
Public Sub Set_DigitalChannel(ByVal Channel As Long)
  SetDigitalChannel (Channel)
End Sub

'Sets all output channels
Public Sub Set_AllDigital()
  SetAllDigital
End Sub

'Reads the status of the input channel
Public Function Read_DigitalChannel(ByVal Channel As Long) As Boolean
  Read_DigitalChannel = ReadDigitalChannel(Channel)
End Function

'Reads the status of all the input channels
Public Function Read_AllDigital() As Long
  Read_AllDigital = ReadAllDigital
End Function

'Reads the content of the pulse counter number 1 or counter number 2
Public Function Read_Counter(ByVal CounterNr As Long) As Long
  Read_Counter = ReadCounter(CounterNr)
End Function

'Resets the 16 bit pulse counter number 1 or counter number 2
Public Sub Reset_Counter(ByVal CounterNr As Long)
  ResetCounter CounterNr
End Sub

'Sets the debounce time to the pulse counter
Public Sub Set_CounterDebounceTime(ByVal CounterNr As Long, ByVal DebounceTime As Long)
  SetCounterDebounceTime CounterNr, DebounceTime
End Sub

'Returns all connected devices as bit field
'bin 0000, dec 0 - No devices found
'bin 0001, dec 1 - card address 0 found
'bin 0010, dec 2 - card address 1 found
'bin 0100, dec 4 - card address 2 found
'bin 1000, dec 8 - card address 3 found
'e.g. value 9 = card 0 and card 3 connected
Public Function Search_Devices() As Long
  Search_Devices = SearchDevices
End Function

'Set the current controlled device 0 thru 3. Returns device address or -1 if specified address not found
Public Function Set_CurrentDevice(ByVal Address As Long) As Long
  Set_CurrentDevice = SetCurrentDevice(Address)
End Function

'Pops up window showing DLL version info
Public Function DLL_Version() As String
  Dim ver As Long
  ver = Version()
  DLL_Version = CStr(ver \ 2 ^ 24) + "." + CStr(&HFF And (ver \ 2 ^ 16)) _
            + "." + CStr(&HFF And (ver \ 2 ^ 8)) + "." + CStr(&HFF And ver)
End Function

